#RunIT-QT Browser Copyright (c) 2015 JJ Posti <techtimejourney.net> 
#RunIT-QT  comes with ABSOLUTELY NO WARRANTY; 
#for details see: http://www.gnu.org/copyleft/gpl.html. 
#This is free software, and you are welcome to redistribute it under 
#GPL Version 2, June 1991
#This is the 0.3 version made with Python and QT5 ")
from PyQt5 import QtCore, QtGui, QtWidgets, QtWebKitWidgets
from PyQt5.QtCore import *
from PyQt5.QtGui import *
from PyQt5.QtWidgets import *
from PyQt5.QtWebKit import *
from PyQt5.QtWebKitWidgets import *
from PyQt5.QtPrintSupport import QPrintPreviewDialog, QPrinter
import os, sys, subprocess
from subprocess import Popen 

class NewPage(QWebPage):
    def __init__(self, parent=None):
        super(NewPage, self).__init__(parent)
          
    def userAgentForUrl(self, url):
        ''' Returns a User Agent that will be seen by the website. '''
        return "Mozilla/5.0 (X11; Linux; rv:10.0) Gecko/20100101 Firefox/50.0"
    def triggerAction(self, action, checked=False):
        if action == QWebPage.OpenLinkInNewWindow:
            self.createWindow(QWebPage.WebBrowserWindow)

        return super(NewPage, self).triggerAction(action, checked)

class NewWindow(QWebView):
    def __init__(self, parent=None):
        super(NewWindow, self).__init__(parent)

        self.NewPage = NewPage(self)

        self.setPage(self.NewPage)

    def createWindow(self, windowType):
        if windowType == QWebPage.WebBrowserWindow:
            self.webView = NewWindow()
            self.webView.setAttribute(Qt.WA_DeleteOnClose, True)

            return self.webView

        return super(NewWindow, self).createWindow(windowType)

class Main(QMainWindow):
    def __init__(self, *args, **kwargs):
        super(Main, self).__init__(*args, **kwargs)

#Title		
        self.setWindowTitle("RunIT-QT")
        self.resize(1500, 500)
#Layouts      
        self.vertical = QVBoxLayout()

#Address bar
        self.address=QLineEdit()
        self.address.returnPressed.connect(self.navigate)
                      
#Search bar
        self.searching=QLineEdit()
        self.searching.returnPressed.connect(self.search)

#Buttons for toolbar
        self.back_button =QPushButton('<-- Back')
        self.back_button.setToolTip('Go Back')
        self.back_button.clicked.connect(self.back)
        
        self.home_button =QPushButton('Home')
        self.home_button.setToolTip('Go Home')
        self.home_button.clicked.connect(self.home)
        
        self.forward_button =QPushButton('Forward -->')
        self.forward_button.setToolTip('Go Forward')
        self.forward_button.clicked.connect(self.forward)
        
        self.reload_button =QPushButton('Reload')
        self.reload_button.setToolTip('Reload Page')
         
        self.printer_button=QPushButton('Print')
        self.printer_button.setToolTip('Print')
        self.printer_button.clicked.connect(self.handlePreview)
                      
        self.zoomin_button=QPushButton('Zoom +')
        self.zoomin_button.setToolTip('Zoom +')
        self.zoomin_button.clicked.connect(self.zoomin)

        self.zoomout_button=QPushButton('Zoom -')
        self.zoomout_button.setToolTip('Zoom -')
        self.zoomout_button.clicked.connect(self.zoomout)
        
        self.bookopen_button=QPushButton('See Bookmarks')
        self.bookopen_button.setToolTip('See Bookmarks')
        self.bookopen_button.clicked.connect(self.bookopen)
        
        self.bookmarks_button=QPushButton('Bookmark')
        self.bookmarks_button.setToolTip('Bookmark addressbar location')
        self.bookmarks_button.clicked.connect(self.bookmarks)
        
        self.download_button=QPushButton('Download')
        self.download_button.setToolTip('Download file from location')
        self.download_button.clicked.connect(self.download)
        self.download_button.clicked.connect(self.loading)
        
        self.vlc_button=QPushButton('Vlc Play')
        self.vlc_button.setToolTip('Play address in Vlc')
        self.vlc_button.clicked.connect(self.vlc)
                
#Toolbar2
        self.toolbar2=QToolBar()
        self.toolbar2.addSeparator()
        self.toolbar2.addWidget(self.back_button)

        self.toolbar2.addWidget(self.address)
        self.toolbar2.addWidget(self.forward_button)
        self.toolbar2.addWidget(self.home_button)
        self.toolbar2.addWidget(self.reload_button)
        self.toolbar2.addWidget(self.vlc_button)

        self.toolbar2.addWidget(self.bookmarks_button)
        self.toolbar2.addWidget(self.bookopen_button)
        self.toolbar2.addWidget(self.download_button)

        self.toolbar2.addWidget(self.searching)
        self.toolbar2.addWidget(self.printer_button)
        self.toolbar2.addWidget(self.zoomin_button)
        self.toolbar2.addWidget(self.zoomout_button)
        self.addToolBar(self.toolbar2)
        self.toolbar2.setLayout(self.vertical)  

#Actual Browser
        self.web=NewWindow()
        self.web.titleChanged = self.setWindowTitle
        self.web.urlChanged.connect(lambda x: self.address.setText(x.toString()))        
        self.web.load(QUrl("http://techtimejourney.net/audax"))
        self.setCentralWidget(self.web)
        
#Web inspector
        self.inspector = QWebInspector()

        self.web.page().settings().setAttribute(
            QWebSettings.DeveloperExtrasEnabled, True
        )
        self.inspector.setPage(self.web.page())
        
#More Browser settings
        self.web.page().settings().setAttribute(QWebSettings.JavascriptEnabled, True)
        self.web.page().settings().setAttribute(QWebSettings.LocalContentCanAccessFileUrls, True)
        self.web.page().settings().setAttribute(QWebSettings.LocalContentCanAccessRemoteUrls, True)
        self.web.page().settings().setAttribute(QWebSettings.LocalStorageEnabled, True)
        self.web.page().settings().setAttribute(QWebSettings.PluginsEnabled, True)
        self.web.page().settings().setAttribute(QWebSettings.PrivateBrowsingEnabled, False)
        self.web.page().settings().setAttribute(QWebSettings.SpatialNavigationEnabled, True)
        self.web.page().settings().setAttribute(QWebSettings.AutoLoadImages, True)
        self.web.page().settings().setAttribute(QWebSettings.AcceleratedCompositingEnabled, True)

#Download functions
    def download(self,widget):
        add=self.address.text()
        home=os.getenv("HOME")
        print home
        os.chdir(home)
        downloaded = 'Downloaded_files' 

        if not os.path.exists(downloaded):
			os.makedirs(downloaded)
        os.chdir(downloaded)
        downloads=subprocess.Popen(['wget', add])
        downloads
        
    def loading(self):
        subprocess.Popen(['notify-send', '-t', '3500', 'Downloading a file to Downloaded_files folder'])
        
#Printer function
    def handlePreview(self):
        dialog = QPrintPreviewDialog()
        dialog.paintRequested.connect(self.handlePaintRequest)
        dialog.exec_()

    def handlePaintRequest(self, printer):
        self.web.render(QPainter(printer))	

#Play in Vlc function
    def vlc(self):
        site=(self.address.text())
        subprocess.Popen(['vlc', site])
#Back function
    def back(self,url):
        goback=self.web.back()
	
#Forward function	
    def forward(self,url):	
        self.web.forward()       

#Reload function
    def reloads(self):	
        self.web.reload()
        
#Home page function
    def home(self):
        self.home = "http://techtimejourney.net/audax"
        self.address.setText(self.home)
        self.web.load(QUrl("http://techtimejourney.net/audax"))
       
#Zooms   
    def zoomin(self):
        self.web.setZoomFactor(self.web.zoomFactor()+.2)

    def zoomout(self):
        self.web.setZoomFactor(self.web.zoomFactor()-.2)
        
#Navigation to address
    def navigate(self):
        url=self.address.text()
        if url.startswith('http://'):
            change=str(url)
            self.address.setText(change)
            self.web.load(QUrl(change))
        
        elif url.startswith('https://'):
            change=str(url)
            self.address.setText(change)
            self.web.load(QUrl(change))
            
        else:
            add="http://" + url
            change=str(add)
            self.address.setText(change)
            self.web.load(QUrl(change))                 			        
        
    def search(self):
        text=self.searching.text()
        adds1="https://duckduckgo.com/?q=" + text 
        self.web.load(QUrl(adds1))
        print adds1

#Bookmark function
    def bookmarks(self,widget):
        home=os.getenv("HOME")
        print home
        site=str(self.address.text())
        os.chdir(home) 
        f = open('.bookmarks.txt', 'a')
        f.write(site)
        f.write('\n')
        f.write('\n')
        f.close()
        subprocess.Popen(['notify-send', '-t', '3500', 'Bookmark created'])
        print site

#Open bookmarks file
    def bookopen(self,widget):
    	home=os.getenv("HOME")
        print home
        home=os.getenv("HOME")
        os.chdir(home)
        head="file:///"
        books=".bookmarks.txt"
        adds=self.address.setText(head + home + '/' + books)
        adda=self.address.text()
        self.web.load(QUrl(adda))                 			        
        
browser=QApplication(sys.argv)
window=Main()
window.show()
browser.exec_()
